/*
Source: www.rabbitoreg.com
Version: 1.0
This demo is created for ordering 4 items out of a pool of 5 (4 correct, one incorrect).

SL variables required:

allSet => (number) If larger than 0, should set the Submit button to normal. Otherwise, set it to disabled
Code => (text) We'll use it store current drag and drop. Each character is either 0 (blank) or a number 1,2,3,4 or 5. The number represents the item dropped on the spot.

Code1, Code2, Code3, Code4 => (text) Individual items to create Code above. Either 0,1,2,3,4,5.

Feedback => (text) Store custom feedback.

step1,step2,step3,step4,step5 => (text) titles of the drop items   

WebObjectFolder => (text) contains the folder name of the webobject folder. Firs time you load a webobject, publish the course to see the folder name. It will not change after each publish anymore.

moreTitle, moreBody => (text) placeholders for the lightbox when user clicks on an item to see details

correctItems, incorrectItems, misplacedItems => (number) correctItems is the number of drag items on the right spot, incorrect items is the number of items should not be dragged on, misplacedItems is the number of items where the items is correct but not on the right spot

*/

var numSteps = 4;
var numDistractors = 1;
var correctVar="";
var incorrectVar="";

// Remove an item from the target list.
function removeDrag(x)
{
	
var p = GetPlayer();
var newCode="";
var feed = "No feedback";
var counter=0;
var curCode="";

// allSet variable triggers the Submit button to be "normal". SL is listening for change of this variable.
p.SetVar("allSet",-1);

// Let's go through the four items.
for (var i = 1; i<=numSteps; i++)
{
	
// curCode is the current code associated with the Code1,Code2,Code3, etc. SL variables	
curCode = p.GetVar("Code"+i);

// if curCode == x, let's remove it
	
 if (curCode==x)
 {
   
// Set the Code associated with x to 0
 newCode+="0";
 p.SetVar("Code"+i,"0");
 }

 else
 {

// this is not to be removed. if it's set (1), let's count how many are there on the target	 
 if (curCode=="1") {counter++;}	 
 newCode+=curCode;
 }
 }
 
// set the new code, with one item remove 
p.SetVar("Code",newCode);

// set feedback based on new code
feed = getFeedback(newCode);

// set the Feedback SL variable based on feedback
p.SetVar("Feedback",feed);


// if we have numSteps items on target, let's enable the submit
if (counter == numSteps)
 {
   p.SetVar("allSet",numSteps);
 }
else
{
 p.SetVar("allSet",0);
}

}

// creates current code based on new drag and drop item (x)
function codeCheck(x)
{
	
var p = GetPlayer();
var newCode="";
var feed = "No feedback";
var acode;
var counter=0;

p.SetVar("allSet",-1);

// let's build the new code  
for (var i = 1; i<=numSteps; i++)
{
 acode = p.GetVar("Code"+i);
 if (acode)
 { 
 newCode+=p.GetVar("Code"+i);
 counter++;
 }
 else
 {
 newCode+="0";
 
 }
 }

// set the new code
p.SetVar("Code",newCode);

// get feedback on the new code
feed = getFeedback(newCode);

//set the Feedback in SL 
p.SetVar("Feedback",feed);

// if we have 4 on target, enable submit
if (counter == numSteps)
 {
   p.SetVar("allSet",numSteps);
 }
else
{
 p.SetVar("allSet",0);
}

}	

// load XML data, slvar is an SL variable name to set as name of the selected process
function dataLoad(id,slvar,slvar_correct,slvar_incorrect)
{
if (slvar_correct)
{	
correctVar = slvar_correct;
}
if (slvar_incorrect)
{	
incorrectVar = slvar_incorrect;
}
loadXML(id,slvar);

}	

// holds feedback
var feedback = new Array();

// holds steps
var stepsArray = new Array();


// actual XML loader
function loadXML(id,slvar)
{
	

// parse doc	
function parse(document){


var p = GetPlayer();

// number of diff processes in doc
var maxProcesses = $(document).find("steps").length;


var cnt =0;

// walks through each process
$(document).find("steps").each(function(){	
 
 cnt = 0;
 
 var stepsid = $(this).attr('stepsId');
 
// is this the process selected?
 if (stepsid == id)
	 
	 { 
 	 
 if (slvar)
 { 

 p.SetVar(slvar,$(this).find('title').text());
 }

// walk through each step in the process 
 $(this).find("step").each(function(){
	 
	 var cid = $(this).attr('stepId');
	
   var ctitle = $(this).find('stepTitle').text();    
   var cdesc = $(this).find('stepDescription').text();

   // build content
  stepsArray[cnt] = new Array();
  stepsArray[cnt]['stepTitle'] = ctitle;
  stepsArray[cnt]['stepId'] = cid;
stepsArray[cnt]['stepBody'] = cdesc;
  cnt++;
   });
	 } 
 });

  
var p = GetPlayer();

// walk through feedback in the process

 $(document).find("feedbacks").each(function(){	
 
 var feedsid = $(this).attr('feedbacksId');
 
 if (feedsid == id)
	 
	 { 
 
 $(this).find("feedback").each(function(){

   var id = $(this).attr('id');
   var feed = $(this).find('feedbackText').text();  
   feedback[id] = new Array();
    feedback[id]['feedbackText']=feed;  
   	var feed = $(this).find('feedbackCorrectText').text();
	if (feed)
	{
	feedback[id]['feedbackCorrectText']=feed;
	}
	var feed = $(this).find('feedbackIncorrectText').text();
	if (feed)
	{
	feedback[id]['feedbackIncorrectText']=feed;
	}
  });  
	 }
  });
 

var p = GetPlayer();

// Setting up drag items 4 correct plus one distractor
for (i=1;i<=(numSteps+numDistractors);i++)
{
p.SetVar("step"+i,stepsArray[i-1]["stepTitle"]);

}	

}

// Ajax call to load xml data
  var p = GetPlayer();
  var slFolder = p.GetVar("WebObjectFolder");
  $.ajax({
    url: 'story_content/WebObjects/'+slFolder+'/card_data.xml', // name of file you want to parse
    dataType: "xml",
    success: parse,
	error: function(){alert("Error: Something went wrong. Can't find the data file." );}
  });



 }
 
 // get more information/description from XML on selected item
 
 function getMoreInfo(itemid)
 {
  var p = GetPlayer();
  if (stepsArray[itemid-1])
  {
    p.SetVar("moreTitle",stepsArray[itemid-1]['stepTitle']);
	
p.SetVar("moreBody",stepsArray[itemid-1]['stepBody']);
	
  }	  
 }
 
 // Let's analyze what's submitted. Provide details on errors: correct, incorrect, misplaced. 
 
 function analyzeSolution()
 {
  var p = GetPlayer();
  var acode;
  var correct=0;
  var misplaced=0;
  var incorrect=0;
  var results = [0,0,0];
  
  for (var i = 1; i<=numSteps; i++)
{
 acode = parseInt(p.GetVar("Code"+i));
 if (acode > 0)
 {	 
 ccode = parseInt(stepsArray[i-1]['stepId']); 


 if (acode>numSteps)
  {
	incorrect++;
  }	 
  else
  {
    if (acode==ccode)
	{
	 correct++;
	}	
	else
	{
	misplaced++;
	}		
  }	  
 
 }
 else
 {
 incorrect++;
 }
 
 
 
 }
 results[0]=correct;
 results[1]=misplaced;
 results[2]=incorrect;
 
 p.SetVar("correctItems",correct);
 p.SetVar("incorrectItems",incorrect);
 p.SetVar("misplacedItems",misplaced);
 
 if (correctVar)
 {
	 p.SetVar(correctVar,feedback['0000']['feedbackCorrectText']);
 }

if (incorrectVar)
 {
	 p.SetVar(incorrectVar,feedback['0000']['feedbackIncorrectText']);
 } 
 
 return results;
 }
 
 function getFeedback(id)
 {



 if (feedback[id]!==undefined)
  {
	  
	  
    return feedback[id]['feedbackText']; 
 }
  else{
	 
  return feedback['0000']['feedbackText'];
  }
  
 }
 function getCompetencyTitle (id)
 {
	 return stepsArray[id]['title'];
 }

